<?php
/**
 * Copyright (C) OElove All rights reserved.
 * <E-Mail：service@phpcoo.com>
 * Url http://www.phpcoo.com
 *     http://www.oephp.com
 *     http://www.OElove.com
 * Update 2021.04.28
 */
header("Content-type: text/html; charset=utf-8");
@set_time_limit(0);
@error_reporting(E_ALL & ~ E_NOTICE);
@date_default_timezone_set("Asia/Shanghai");
define('BASE_ROOT', dirname(__FILE__).'/');
require_once(BASE_ROOT."source/core/oephp/Application.php");
require_once(BASE_ROOT."source/core/oephp/oelove.init.php");
$upgrade_title = "OEloveFreeV8.0_to_V8.1";
$upgrade_version = "OEloveV8.1";
echo("<html>\n");
echo("<head>\n");
echo("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n");
echo("<title>".$upgrade_title."升级程序</title>\n");
echo("<style>body{padding:20px;text-align:center;font-size:14px; color:#333;}p{line-height:25px;}</style>");
echo("</head>\n");
echo("<body>\n");
$action = XRequest::getArgs('action');

if (empty($action)){
	echo("
		<p>本程序用于升级 ".$upgrade_title."</p>
		<p><a href='upgrade.php?action=upgrade'>请点执行升级</a></p>
	");
}
elseif ($action == 'upgrade'){
	echo("
		<p>本程序用于升级 ".$upgrade_title."</p>
		<p><font color='red'>数据表升级，请稍等......</font></p>
	");

    update_seo();
    update_user();
    update_guest();
    update_log_admin();
    update_log_user();
    
    update_emtest();
    update_emlogs();
    update_empay_logs();
    update_emresult();
    update_emsubject();
    update_marry_statement();
    
	//升级完成
	echo("<p><font color='green'>恭喜你，数据表升级成功！<br /><a href='upgrade.php'>返回升级页面</a>  <a href='upgrade.php?action=del'>删除升级文件</a></p>");
}

elseif ($action == 'del') {
    OE::loadUtil('file');
    XFile::delFile('upgrade.php');
	echo("<font color=red>升级文件删除成功</font>");
}
/*------------------------------- update Start --------------------------*/

//SEO
function update_seo() {
    $table = "seo";
    if (true === check_exist_table($table)) {
        
		//测试频道
		$sql = "SELECT * FROM ".DB_PREFIX.$table." WHERE `idmark`='ch_emtest_index'";
		$rows = OE::$obj->fetch_first($sql);
		if (empty($rows)) {
            $id = OE::$obj->fetch_newid("SELECT MAX(id) FROM ".DB_PREFIX.$table."", 1);
			$addon_array = array(
                'id'=>$id,
                'idmark'=>'ch_emtest_index',
                'chname'=>'情感测试模块首页',
				'title'=>'情感测试-{sitename}',
                'description'=>'',
                'keyword'=>'',
                'orders'=>$id,
			);
			OE::$obj->insert(DB_PREFIX.$table, $addon_array);
			unset($addon_array);
		}
		unset($sql, $rows);
        
        //测试列表
		$sql = "SELECT * FROM ".DB_PREFIX.$table." WHERE `idmark`='ch_emtest_list'";
		$rows = OE::$obj->fetch_first($sql);
		if (empty($rows)) {
            $id = OE::$obj->fetch_newid("SELECT MAX(id) FROM ".DB_PREFIX.$table."", 1);
			$addon_array = array(
                'id'=>$id,
                'idmark'=>'ch_emtest_list',
                'chname'=>'情感测试列表',
				'title'=>'情感测试列表-{sitename}',
                'description'=>'',
                'keyword'=>'',
                'orders'=>$id,
			);
			OE::$obj->insert(DB_PREFIX.$table, $addon_array);
			unset($addon_array);
		}
		unset($sql, $rows);
        
        //测试详情
        $sql = "SELECT * FROM ".DB_PREFIX.$table." WHERE `idmark`='ch_emtest_detail'";
		$rows = OE::$obj->fetch_first($sql);
		if (empty($rows)) {
            $id = OE::$obj->fetch_newid("SELECT MAX(id) FROM ".DB_PREFIX.$table."", 1);
			$addon_array = array(
                'id'=>$id,
                'idmark'=>'ch_emtest_detail',
                'chname'=>'情感测试详情',
				'title'=>'{title}-情感测试详情-{sitename}',
                'description'=>'',
                'keyword'=>'',
                'orders'=>$id,
			);
			OE::$obj->insert(DB_PREFIX.$table, $addon_array);
			unset($addon_array);
		}
		unset($sql, $rows);
        
    }
    echo "<font color='blue'>[".$table."]表更新成功</font><br />";
}


//会员表
function update_user() {
    $table = "user";
    if (true === check_exist_table($table)) {
		$array = array(
            //手机归属地
            "mobileaddr"=>"ADD `mobileaddr` varchar(60) DEFAULT '' AFTER `mobile`",
            //手机运营商
            "mobileisp"=>"ADD `mobileisp` varchar(30) DEFAULT '' AFTER `mobileaddr`",
            
            //婚况声明状态 1-已声明，0-未声明，2-已到期
            "statement"=>"ADD `statement` tinyint(1) unsigned DEFAULT '0' AFTER `yuntime`",
            //最后声明时间
            "statement_time"=>"ADD `statement_time` int(10) unsigned DEFAULT '0' AFTER `statement`",
            //声明有效期
            "statement_validtime"=>"ADD `statement_validtime` int(10) unsigned DEFAULT '0' AFTER `statement_time`",
            
            //身份证住址
            "address"=>"ADD `address` varchar(60) DEFAULT '' AFTER `idnumber`",
		);
		foreach ($array as $key=>$value) {
			$field = $key;
			$sql = $value;
			run_altertable($table, $field, $sql);
		}
		unset($array);
    }
    echo "<font color='blue'>[".$table."]表更新成功</font><br />";
}


//游客表
function update_guest() {
    $table = "guest";
    if (true === check_exist_table($table)) {
		$array = array(
            //手机归属地
            "mobileaddr"=>"ADD `mobileaddr` varchar(60) DEFAULT '' AFTER `tmonth`",
            //手机运营商
            "mobileisp"=>"ADD `mobileisp` varchar(30) DEFAULT '' AFTER `mobileaddr`",
		);
		foreach ($array as $key=>$value) {
			$field = $key;
			$sql = $value;
			run_altertable($table, $field, $sql);
		}
		unset($array);
    }
    echo "<font color='blue'>[".$table."]表更新成功</font><br />";
}

//admin日志表
function update_log_admin() {
    $table = "log_admin";
    if (true === check_exist_table($table)) {
		$array = array(
            "dowhat"=>"MODIFY `dowhat` varchar(1000) NULL DEFAULT ''",
		);
		foreach ($array as $key=>$value) {
			$field = $key;
			$sql = $value;
			run_altertable($table, $field, $sql);
		}
		unset($array);
    }
    echo "<font color='blue'>[".$table."]表更新成功</font><br />";
}

//user日志表
function update_log_user() {
    $table = "log_user";
    if (true === check_exist_table($table)) {
		$array = array(
            "dowhat"=>"MODIFY `dowhat` varchar(1000) NULL DEFAULT ''",
		);
		foreach ($array as $key=>$value) {
			$field = $key;
			$sql = $value;
			run_altertable($table, $field, $sql);
		}
		unset($array);
    }
    echo "<font color='blue'>[".$table."]表更新成功</font><br />";
}

//测试主题
function update_emtest() {
    $table = 'emtest';
    if (false === check_exist_table($table)) {
        $sql =	  "`testid` int(10) unsigned NOT NULL AUTO_INCREMENT,".
                  "`title` varchar(255) DEFAULT '',".
                  "`subtitle` varchar(255) DEFAULT '',".
                  "`thumbimg` varchar(100) DEFAULT '',".
                  "`drawimg` varchar(100) DEFAULT '',".
                  "`intro` varchar(1000) DEFAULT '',".
                  "`remark` varchar(255) DEFAULT '',".
                  "`score_standard` varchar(500) DEFAULT '',".
                  "`score_basis` varchar(500) DEFAULT '',".
                  "`addtime` int(10) unsigned DEFAULT '0',".
                  "`flag` tinyint(1) unsigned DEFAULT '0',".
                  "`elite` tinyint(1) unsigned DEFAULT '0',".
                  "`hits` int(10) unsigned DEFAULT '0',".
                  "`test_nums` int(10) unsigned DEFAULT '0',".
                  "`fee` decimal(18,2) unsigned DEFAULT '0.00',".
                  "PRIMARY KEY (`testid`),".
                  "KEY `title` (`title`),".
                  "KEY `flag` (`flag`),".
                  "KEY `elite` (`elite`)";
        OE::$obj->create_table(DB_PREFIX.$table, $sql);
    }
	echo "<font color='blue'>[".$table."]表创建成功</font><br />"; 
}

//测试记录表
function update_emlogs() {
    $table = 'emlogs';
    if (false === check_exist_table($table)) {
        $sql =	  "`logid` int(10) unsigned NOT NULL AUTO_INCREMENT,".
                  "`logsn` varchar(50) DEFAULT '',".
                  "`userid` int(10) unsigned DEFAULT '0',".
                  "`testid` int(10) unsigned DEFAULT '0',".
                  "`resultid` int(10) unsigned DEFAULT '0',".
                  "`score` decimal(18,2) unsigned DEFAULT '0.00',".
                  "`result` varchar(2000) DEFAULT '',".
                  "`addtime` int(10) unsigned DEFAULT '0',".
                  "PRIMARY KEY (`logid`),".
                  "KEY `logsn` (`logsn`),".
                  "KEY `userid` (`userid`),".
                  "KEY `testid` (`testid`),".
                  "KEY `resultid` (`resultid`)";
        OE::$obj->create_table(DB_PREFIX.$table, $sql);
    }
	echo "<font color='blue'>[".$table."]表创建成功</font><br />"; 
}

//测试支付表
function update_empay_logs() {
    $table = 'empay_logs';
    if (false === check_exist_table($table)) {
        $sql =	  "`logid` int(10) unsigned NOT NULL AUTO_INCREMENT,".
                  "`userid` int(10) unsigned DEFAULT '0',".
                  "`testid` int(10) unsigned DEFAULT '0',".
                  "`fee` decimal(18,2) unsigned DEFAULT '0.00',".
                  "`paytype` varchar(30) DEFAULT '',".
                  "`payid` int(10) unsigned DEFAULT '0',".
                  "`paynum` varchar(50) DEFAULT '',".
                  "`addtime` int(10) unsigned DEFAULT '0',".
                  "`remark` varchar(255) DEFAULT '',".
                  "PRIMARY KEY (`logid`),".
                  "KEY `userid` (`userid`),".
                  "KEY `testid` (`testid`),".
                  "KEY `paytype` (`paytype`)";
        OE::$obj->create_table(DB_PREFIX.$table, $sql);
    }
	echo "<font color='blue'>[".$table."]表创建成功</font><br />"; 
}

//测试答案表
function update_emresult() {
    $table = 'emresult';
    if (false === check_exist_table($table)) {
        $sql =	  "`resultid` int(10) unsigned NOT NULL AUTO_INCREMENT,".
                  "`testid` int(10) unsigned DEFAULT '0',".
                  "`minscore` decimal(18,2) unsigned DEFAULT '0.00',".
                  "`maxscore` decimal(18,2) unsigned DEFAULT '0.00',".
                  "`result` varchar(2000) DEFAULT '',".
                  "`orders` smallint(6) unsigned DEFAULT '0',".
                  "`addtime` int(10) unsigned DEFAULT '0',".
                  "`score_nums` int(10) unsigned DEFAULT '0',".
                  "PRIMARY KEY (`resultid`),".
                  "KEY `testid` (`testid`),".
                  "KEY `minscore` (`minscore`),".
                  "KEY `maxscore` (`maxscore`),".
                  "KEY `orders` (`orders`)";
        OE::$obj->create_table(DB_PREFIX.$table, $sql);
    }
	echo "<font color='blue'>[".$table."]表创建成功</font><br />"; 
}

//测试题目表
function update_emsubject() {
    $table = 'emsubject';
    if (false === check_exist_table($table)) {
        $sql =	  "`subid` int(10) unsigned NOT NULL AUTO_INCREMENT,".
                  "`testid` int(10) unsigned DEFAULT '0',".
                  "`subname` varchar(255) DEFAULT '',".
                  "`orders` smallint(6) unsigned DEFAULT '0',".
                  "`options` varchar(5000) DEFAULT '',".
                  "`addtime` int(10) unsigned DEFAULT '0',".
                  "PRIMARY KEY (`subid`),".
                  "KEY `testid` (`testid`),".
                  "KEY `subname` (`subname`),".
                  "KEY `orders` (`orders`)";
        OE::$obj->create_table(DB_PREFIX.$table, $sql);
    }
	echo "<font color='blue'>[".$table."]表创建成功</font><br />"; 
}

//单身声明表
function update_marry_statement() {
    $table = 'marry_statement';
    if (false === check_exist_table($table)) {
        $sql =	  "`logid` int(10) unsigned NOT NULL AUTO_INCREMENT,".
                  "`logsn` varchar(32) DEFAULT '',".
                  "`userid` int(10) unsigned DEFAULT '0',".
                  "`truename` varchar(50) DEFAULT '',".
                  "`idnumber` varchar(30) DEFAULT '',".
                  "`birthday` varchar(20) DEFAULT '',".
                  "`country` varchar(50) DEFAULT '',".
                  "`address` varchar(100) DEFAULT '',".
                  "`gender` tinyint(2) unsigned DEFAULT '0',".
                  "`national` varchar(50) DEFAULT '',".
                  "`marry` varchar(20) DEFAULT '',".
                  "`sign_name` varchar(100) DEFAULT '',".
                  "`sign_time` int(10) unsigned DEFAULT '0',".
                  "`valid_time` int(10) unsigned DEFAULT '0',".
                  "`flag` tinyint(1) unsigned DEFAULT '0',".
                  "`remark` varchar(255) DEFAULT '',".
                  "`addtime` int(10) unsigned DEFAULT '0',".
                  "`uptime` int(10) unsigned DEFAULT '0',".
                  "`wit_company` varchar(200) DEFAULT '',".
                  "`wit_stamp` varchar(200) DEFAULT '',".
                  "`rplogsn` varchar(32) DEFAULT '',".
                  "`guide_company` varchar(200) DEFAULT '',".
                  "`guide_stamp` varchar(200) DEFAULT '',".
                  "`guide_company2` varchar(200) DEFAULT '',".
                  "`guide_stamp2` varchar(200) DEFAULT '',".
                  "`guide_company3` varchar(200) DEFAULT '',".
                  "`guide_stamp3` varchar(200) DEFAULT '',".
                  "`audittime` int(10) unsigned DEFAULT '0',".
                  "`audituser` varchar(30) DEFAULT '',".
                  "`auditremark` varchar(255) DEFAULT '',".
                  "PRIMARY KEY (`logid`),".
                  "KEY `logsn` (`logsn`),".
                  "KEY `userid` (`userid`),".
                  "KEY `truename` (`truename`),".
                  "KEY `idnumber` (`idnumber`),".
                  "KEY `gender` (`gender`),".
                  "KEY `sign_time` (`sign_time`),".
                  "KEY `valid_time` (`valid_time`),".
                  "KEY `flag` (`flag`),".
                  "KEY `rplogsn` (`rplogsn`)";
        OE::$obj->create_table(DB_PREFIX.$table, $sql);
    }
	echo "<font color='blue'>[".$table."]表创建成功</font><br />"; 
}


//索引表
function update_index() {
    
    
}


/*------------------------------- update End --------------------------*/


/*--------------------------- 数据表操作函数 Start ----------------------------*/
/**
 * 更新数据表字段
 * @param:: string $table 表名 不带前缀
 * @param:: string $field 字段名
 * @param:: string $sql SQL语句
 * @return:: null
*/
function run_altertable($table, $field, $sql){
    if (!empty($field) && !empty($sql)) {
        $alter_action = 0;
		if (strtoupper(substr($sql, 0, 9)) == 'ADD INDEX') {
			$alter_action = 4;
		} 
		elseif (strtoupper(substr($sql, 0, 3)) == 'ADD') {
			$alter_action = 1;
		}
        elseif (strtoupper(substr($sql, 0, 6)) == 'CHANGE') {
            $alter_action = 2;
		} 
        elseif (strtoupper(substr($sql, 0, 6)) == 'MODIFY') {
            $alter_action = 2;
		} 
        elseif (strtoupper(substr($sql, 0, 4)) == 'DROP') {
            $alter_action = 3;
		}
        elseif (strtoupper(substr($sql, 0, 10)) == 'DROP INDEX') {
            $alter_action = 4; 
        }
        
        //创建字段
		if ($alter_action == 1) {
			//不存在字段才创建
            if (false === check_exist_field($table, $field)) {
                OE::$obj->alter_table(DB_PREFIX.$table, $sql);
			}
		} 
        //修改字段
        elseif ($alter_action == 2) {
			//存在字段才修改
            if (true === check_exist_field($table, $field)) {
                OE::$obj->alter_table(DB_PREFIX.$table, $sql);
			}
		} 
        //删除字段
        elseif ($alter_action == 3) {
			//存在字段才删除
            if (true === check_exist_field($table, $field)) {
                OE::$obj->alter_table(DB_PREFIX.$table, $sql);
            }
		}
		//创建、删除索引 
		elseif ($alter_action  == 4) {
			//存在字段才执行建索引
            if (true === check_exist_field($table, $field)) {
                OE::$obj->alter_table(DB_PREFIX.$table, $sql);
			}
		}
	}
}

/**
 * 判断数据表是否含有某个字段
 * @param:: string $table 表名 不带前缀
 * @param:: string $field 字段名
 * @return:: bool true/false
*/
function check_exist_field($table, $field){
	$array_column = array();
	$columns = get_table_columns($table);
	$i = 0;
	if (!empty($columns)) {
        foreach($columns as $key=>$value){
            if (empty($array_column)) {
                $array_column = array(
                    $i=>$key
                );
            }
            else {
                $array_column = array_merge($array_column, array($i=>$key));
            }
			$i++;
		}
        if (in_array($field, $array_column)) {
            return true;
        }
        else {
            return false;
        }
	}
    else {
		//die($table."Not exists!");
	}
}

/**
 * 获取某个数据表所有字段名
 * @param:: string $table 数据表名 不带前缀
 * @return:: array
*/
function get_table_columns($table) {
    $tablecolumns = array();
	if (OE::$obj->version() > '4.1') {
		$query = OE::$obj->query("SHOW FULL COLUMNS FROM ".DB_PREFIX."{$table}", 'SILENT');
	} 
    else {
		$query = OE::$obj->query("SHOW COLUMNS FROM ".DB_PREFIX."{$table}", 'SILENT');
	}
	while ($field = @OE::$obj->fetch_array($query)) {
		$tablecolumns[$field['Field']] = $field;
	}
	return $tablecolumns;
}

/**
 * 检测是否含有数据表
 * @param:: string $table 表名 不带前缀
 * @return:: bool true/false
*/
function check_exist_table($table) {
	$status = false;
    $status = OE::$obj->table_exist($table);
	return $status;
}

/*-------------------------- 数据表操作函数 End ------------------------------*/
echo("</body>\n");
echo("</html>");
?>